/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                       EPI Serena, INRIA Paris                       */
/*                                                                     */
/*  Copyright (c) 2005-2017 INRIA.                                     */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: phrase.cpp,v 1.13 2017/05/31 15:54:21 fclement Exp $ */

#include "phrase.hpp"


using namespace std;

namespace io{

  Phrase::Phrase():_values(0){}
  
  Phrase::Phrase(vector<Typed_value> &__values):_values(__values){}
  
  Phrase::Phrase(const Typed_value & _value):_values(1,_value){}

  Phrase::~Phrase(){}

  vector<Typed_value> & Phrase::values(){return _values;}

  void Phrase::add(const Typed_value& _value){
    _values.push_back(_value);
  }
  

}
