(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: main.ml,v 1.13 2017/01/04 11:58:31 fclement Exp $ *)

module Nat = Unatural;;
module S = Ustring;;
module A = Uarray;;

let string_sort s =
  let len = S.length s in
  let a =
    A.init len (fun i ->
      (* Now, we have 0 <= i < len.
         Therefore, the next S.unsafe_get will be safe. *)
      S.unsafe_get s i) in
  A.sort Pervasives.compare a;
  let buf = Buffer.create (Nat.to_int len) in
  A.iter (Buffer.add_char buf) a;
  Buffer.contents buf
;;

let main () =
  let ib = Scanf.Scanning.stdin in
  let ob = Buffer.create 255 in
  while not (Scanf.Scanning.end_of_input ib) do
    Scanf.bscanf ib "%[^\n]" (Buffer.add_string ob);
    Scanf.bscanf ib "%[\n]" (Buffer.add_string ob);
  done;
  Printf.printf "%s" (string_sort (Buffer.contents ob));
  Buffer.clear ob;
  exit 0
;;

main ();;
