(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: misc_sprint.ml,v 1.8 2017/01/04 11:58:31 fclement Exp $ *)

type 'a printer = 'a Og_types.printer;;
type 'a string_printer = string -> 'a -> string;;
type ('a, 'b) string_printer_lifter = 'a printer -> 'b string_printer;;

let format_sprint printer ident x =
  let ppf = Format.str_formatter in
  Format.fprintf ppf "@[<hv 4>@ %s =@ %a@]"
    ident
    (printer Og_precedence.Ck_toplevel) x;
  Format.flush_str_formatter ()
;;

let sprint_int = format_sprint Og_printer.printer_Int;;

let sprint_int_list =
  format_sprint (Og_printer.printer_List Og_printer.printer_Int)
;;
