(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: main.ml,v 1.8 2017/01/04 11:58:31 fclement Exp $ *)

let task_engines =
  {
   Worker.init_engine = Model.init_engine;
   light_comp_engine = Model.light_comp_engine;
   heavy_comp_engine = Model.heavy_comp_engine;
   final_engine = Model.final_engine;
  }
;;

let tasks = Worker.make_tasks task_engines;;

let main () =
  Model.initialization ();
  Worker.main_loop tasks
;;

main ();;
