(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: spawnlib.mli,v 1.30 2017/01/04 11:58:29 fclement Exp $ *)

(** {3 Common functions, used in the Sklml parallel launcher daemon} *)

open Tools_common_types;;
open Daemon_types;;

val fail : string -> 'a;;

val maybe : 'a option -> (unit -> 'b) -> ('a -> 'b) -> 'b;;

val install_sighandlers : unit -> unit;;
val spawn_sock : (IO.t -> 'a -> unit) -> 'a -> port;;

val request_slave : IO.t -> spawn_request -> spawn_reply;;
val slave_loop : IO.t -> (spawn_request -> spawn_reply) -> unit;;

type ('state, 'req) request_handler = 'req -> 'state;;
type ('state, 'req) request_generator = 'state -> 'req option;;

val master_loop :
  ('a, 'b) request_generator -> ('a, 'b) request_handler -> 'a -> 'a
;;
