(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: parser.mli,v 1.15 2017/01/04 11:58:30 fclement Exp $ *)

type 'a t
and 'a parser = 'a t
;;

val parse : 'a t -> string -> 'a option;;
val full_parse : 'a t -> string -> ('a * string) option;;

val return : 'a -> 'a t;;
val zero : 'a t;;
val bind : 'a t -> ('a -> 'b t) -> 'b t;;
val plus : 'a t -> 'a t -> 'a t;;
val ( >>= ) : 'a t -> ('a -> 'b t) -> 'b t;;
val ( >> ) : 'a t -> 'b t -> 'b t;;
val ( +++ ) : 'a t -> 'a t -> 'a t;;

val any : 'a t list -> 'a t;;
val many : 'a t -> 'a list t;;
val many1 : 'a t -> 'a list t;;
val many_till : 'a t -> 'b t -> 'b list t;;
val times : Unatural.t -> 'a t -> 'a list t;;
val less_than : Unatural.t -> 'a t -> 'a list t;;
val maybe : 'a t -> 'a option t;;

val char : char -> char t;;
val eof : unit t;;
