(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: parser_plus.mli,v 1.16 2017/01/04 11:58:30 fclement Exp $ *)

(** {3 More parsing operations}

 Defines common parsers and helper functions. *)

val nums : char list;;
val alphas : char list;;
val spaces : char list;;

(** {6 Helper functions} *)

val p_ignore : 'a Parser.t -> unit Parser.t;;
val notc : char list -> char list;;
val to_nat : char list -> Unatural.t;;
val to_num : char list -> int;;

(** {6 Common parsers} *)

val p_digit : char Parser.t;;
val p_natural : Unatural.t Parser.t;;
val p_integer : int Parser.t;;

val p_letter : char Parser.t;;
val p_space : char Parser.t;;
val p_ident : string Parser.t;;
val p_word : string -> unit Parser.t;;
