(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2007-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux                                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: sklml_path.mli,v 1.4 2017/01/04 11:58:30 fclement Exp $ *)

open Tools_common_types;;

val get_compiler_and_lib_suffix : compilation_mode -> path * suffix;;
val get_generator : generator_kind -> path;;

val system_libs : lib list;;
val pph_libs : lib list;;
val pph_include_dir : root_dir -> path -> inc;;
val sklml_compilation_include_dirs : root_dir -> inc list;;
val sklml_libs : semantics_mode -> lib list;;
val sklml_link_include_dirs : root_dir -> semantics_mode -> inc list;;

val get_sklml_lib_root_dir : root_dir -> lib;;
val get_sklml_pph_tekno_dir : root_dir -> path;;
